﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Activation;
using System.Data.Linq;

namespace ServiceLibrary
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class ToDoService : IToDoService
    {
        #region IToDoService Members
        public ToDo GetToDo(long ID)
        {
            DataClasses1DataContext context = new DataClasses1DataContext();
            var toDos = from p in context.ToDos
                        where p.ID == ID
                        select p;
            List<ToDo> listTodos =  toDos.ToList();
            if (listTodos != null && listTodos.Count > 0)
            {
                return listTodos[0];
            }
            else
            {
                return null;
            }
        }

        public ToDo AddToDo(ToDo toDo)
        {
            DataClasses1DataContext context = new DataClasses1DataContext();
            context.ToDos.InsertOnSubmit(toDo);
            context.SubmitChanges();
            return toDo;
        }

        public bool DeleteToDo(ToDo todo)
        {
            try
            {
                DataClasses1DataContext context = new DataClasses1DataContext();
                context.ToDos.Attach(todo);
                context.ToDos.DeleteOnSubmit(todo);
                context.SubmitChanges();
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("Exception In Service", ex);
            }
        }

        public ToDo UpdateToDo(ToDo todo)
        {
            try
            {
                DataClasses1DataContext context = new DataClasses1DataContext();

                ToDo temptodo = context.ToDos.Single(p => p.ID == todo.ID);
                temptodo.Description = todo.Description;
                temptodo.Status = todo.Status;

                context.SubmitChanges();
                return temptodo;
            }
            catch (Exception ex)
            {
                throw new Exception("Exception In Service",ex);
            }
        }

        public List<ToDo> GetAllToDo()
        {
            try
            {
                DataClasses1DataContext context = new DataClasses1DataContext();
                var toDos = from p in context.ToDos
                            select p;
                return toDos.ToList();
            }
            catch (Exception ex)
            {
                throw new Exception("Exception In Service", ex);
            }
        }

        #endregion
    }
}
